<?php
namespace Fiscal\Repositories;

use \Geral\Entities\Itemproduto;
class Incidencia extends \Doctrine\ORM\EntityRepository
{

    /**
     * Chama a funcao INCIDENCIA_PRODUTO que verifica os impostos sobre o produto.
     *
     * @param Itemproduto $itemproduto
     * @param $cdgrupofisc
     *
     * @return array|bool
     */
    public function retornaIncidenciaProduto(Itemproduto $itemproduto, $cdgrupofisc){
        $sql = "
            SELECT * FROM TABLE(INCIDENCIA_PRODUTO(
                   :P_ENTRSAIDIN, :P_EMPRESA, :P_PRODUTO,
                   :P_INSCESTA, :P_TIPOOPER, :P_FILIAL,
                   :P_LANCTONF, :P_CDGRUPOFISC, :P_CDGRPFISCSV,
                   :P_IDINCINTEREST, :P_IDSISTEMA))
        ";
        $params = array(
            'P_ENTRSAIDIN'    => $itemproduto->getLanctonf()->getEntrsaidop()->getIdentrsaidop(),
            'P_EMPRESA'       => $itemproduto->getLanctonf()->getEmpresa()->getCdempresa(),
            'P_PRODUTO'       => $itemproduto->getCdproduto(),
            'P_INSCESTA'      => $itemproduto->getLanctonf()->getInscesta()->getCdinscesta(),
            'P_TIPOOPER'      => $itemproduto->getLanctonf()->getEntrsaidop()->getCdtipooper(),
            'P_FILIAL'        => $itemproduto->getLanctonf()->getFilial()->getCdfilial(),
            'P_LANCTONF'      => $itemproduto->getLanctonf()->getNrlanctonf(),
            'P_CDGRUPOFISC'   => $cdgrupofisc,
            'P_CDGRPFISCSV'   => '',
            'P_IDINCINTEREST' => 'N',
            'P_IDSISTEMA'     => 'DF'.$itemproduto->getLanctonf()->getEntrsaidop()->getIdentrsaidop()
        );

        $result = self::getEntityManager()->getConnection()->fetchAll($sql, $params);
        return count($result) > 0 ? $result : false;
    }
}